c*************************************************************************
c
c			PROGRAM DECONVOLUTION
c	 		(using Maximum Entropy)
c			UCLES Version
c
c	2009-08-17:	"adaptive error" (in comment field)
c			
c*************************************************************************

	implicit none

	integer maxsize,maxsize2

	parameter(maxsize=5000)
	parameter(maxsize2=100000)

	real g(maxsize),phi(maxsize),f(maxsize),s(maxsize)
	real matPHI(maxsize,maxsize),g_simu(maxsize)
	real g_mem(maxsize),s_mem(maxsize),X(maxsize)
	real eta,dummy,sumphi,x1,x2,x3,fmax,fchi2,gdummy
	real eta_input,eta_default
	real f_conv(maxsize),g_samp(maxsize),f_test(maxsize)
	real truef(maxsize),resid(maxsize),f_1(maxsize)
	real f_1conv(maxsize),deconv(maxsize),gsimu(maxsize)
	real gsub(maxsize),g_edge(maxsize),g_conv(maxsize)
	real overg(maxsize),overgedge(maxsize),overphi(maxsize)
	real maxg,summatrix,ftest(maxsize),gtest(maxsize)
	real ftest2(maxsize),gtest2(maxsize)
c	real spectrum(maxsize),spec_deconv(maxsize2)
	REAL*8 spectrum(maxsize),spec_deconv(maxsize2)
	real errorspec(maxsize),phi_dummy(maxsize)
	real lambda,errorfac

	real*8 error,minimum,par(10),rest,oldrest,minrest
	real*8 par_min(10),var,ampl

	integer sizg,sizf,sizphi,niter,sizfconv,sizgsimu
	integer i,k,l,j,pixel(9999),q,p,n1,count,iter,nchunks
	integer sizefnew,minindex,width,sizeophi,sampling
	integer sizftest,sizgtest,sizftest2,sizgtest2
	integer npixel,overlap,specindex,specindex2,chunk
	integer negflag

c	UVES:
	INTEGER order,header,startpix,mask(9999)
	INTEGER funny_chunk

	character reply
	character*50 fn1,fn2,fn3


c=================================================================================


	write(*,*)'**********************************************'
	write(*,*)'*						*'
	write(*,*)'*	UCLES - DECONVOLUTION 			*'
	write(*,*)'*                                            *'
	write(*,*)'*		Maximum Entropy Method		*'
	write(*,*)'*                                            *'
	write(*,*)'**********************************************'


c---	hardcoded first:

c	sizphi=49
	q=5
c	p=24

c---
c	for 1E+06 resolution:
	sampling=10
c---

	eta_default = 1E-09
	
c----------------------------------------------------------------------------------
c
c	Now using new inputfile INPUT3:
c
c----------------------------------------------------------------------------------

	open(12,file='./plot/deconv/input4',type='old')


	write(*,*)'Reading INPUT4 file...'
	read(12,*)reply
	read(12,*)sizg
	write(*,*)'OK, ',sizg,' pixel in spectrum chunk.'
	read(12,*)reply
	read(12,*)overlap
	write(*,*)'Reading ',overlap,' pixel more on each side!'

	sizg=sizg+2*overlap	
	write(*,*)'NEW size of g (+2*overlap):',sizg

	read(12,*)reply
	read(12,*)nchunks
	write(*,*)'OK, number of chunks=',nchunks
c----	new IP info:
	read(12,*)reply
        read(12,*)sizphi,p 
c----
	sizf=sizg*q+(2*p)

	write(*,*)'OK, Size of oversampled f-vector (+2*p)=',sizf
	sizefnew=sizg*q
	write(*,*)'OK, Size of oversampled f-vector(only)=',sizefnew

c	write(*,*)'OK, now number of MEM iterations/loop:'
        read(12,*)reply
        read(12,*)niter
c        write(*,*)'And now eta for MEM:'
        read(12,*)reply

c        read(12,*)eta
	read(12,*) eta_input	

        write(*,*)'OK, total number of Iterations:',niter
        write(*,*)'OK, eta for MEM:',eta_input

	read(12,*)reply

	read(12,*)fn1
	write(*,*)'OK, Spectrum to deconvolve=',fn1
	read(12,*)reply
	read(12,*)npixel
	write(*,*)'OK, Number of pixels:',npixel
	read(12,*)reply
	read(12,*) order
	write(*,*)'OK, HIRES order to deconv.= ',order

	read(12,*) reply
        READ(12,*) startpix
	WRITE(*,*) 'Starting with pixel: ',startpix

	read(12,*) reply
	READ(12,*) header

	WRITE(*,*)'OK, that many header lines: ',header

	read(12,*) reply
	READ(12,*) funny_chunk

	read(12,*) reply
	read(12,*) errorfac
	write(*,*)'OK, factor for error vector= ',errorfac

	write(*,*) 'Lets rock?'


	open(17,file='./plot/deconv/'//fn1)
ccc	open(18,file='./plot/deconv/'//fn3)
	open(15,file='./plot/deconv/deconv.dat')

c----	jump over header ------------------------------------

c	Header:

	WRITE(*,*) 'OK, Jumping over ',header,' header lines.'
	
	do i=1,header

		read(17,*)reply

ccc		read(18,*)reply
	end do

c------------------------------------------------------------

c	just jumping over 1 pixel to avoid edge effects at the conv. 
c	do i=1,5
c	NO jump at all I need all 5 first pixel:
c		read(17,*)dummy
c	end do

	write(*,*)'......reading spectrum to deconvolve...'
	write(*,*)'OK, reading file:',fn1

	WRITE(*,*)
	WRITE(*,*)'======> Jumping to order: ',order

	do i=1,order-1
c	do i=15,order-1

		WRITE(*,*)'Order = ',i
		
		do j=1,npixel
		read(17,*) pixel(1),lambda,spectrum(1),errorspec(1)
		end do
	
	end do
	
	WRITE(*,*)'OK, last row read:', pixel(1),lambda,
&spectrum(1),errorspec(1)

	WRITE(*,*)'....DONE'


c------------------------------------------------------------
c	READING SPECTRUM:

c	write(*,*)'PIXEL FLUX ERROR'

	negflag=0

	do i=1,npixel

		read(17,*) pixel(i),lambda,spectrum(i),errorspec(i),mask(i)

ccc		read(18,*)pixel,errorspec(i)
c		write(*,*)pixel,spectrum(i),errorspec(i)

c===		Mask checking:
		IF (mask(i).eq.6) THEN 
			errorspec(i)=spectrum(i)*2.
			IF (spectrum(i).eq.0.) THEN
				errorspec(i)=1.
			END IF
		END IF
c===

c===		checking if flux is negative!

		IF (spectrum(i).lt.0.) THEN
			WRITE(*,*)'NEGATIVE FLUX:',spectrum(i),' INDEX: ',i 
			WRITE(*,*)'REPLACED WITH POSITIVE VALUE...'
			spectrum(i)=ABS(spectrum(i))
			errorspec(i)=spectrum(i)*2.
		END IF
		


	end do

c	IF (order.eq.24) THEN
c		do i=955,1053
c		errorspec(i)=1D+06
c		end do
c	END IF



cc	close(17)
ccc	close(18)

	WRITE(*,*)' OK, input(1) & input(',npixel,'):'
	WRITE(*,*) pixel(1),spectrum(1),errorspec(1)
	WRITE(*,*) pixel(npixel),spectrum(npixel),errorspec(npixel)

c---	Normalizing complete spectrum to avoid jumps between
c	the chunks


	maxg=0.

	do i=1,npixel

		if (spectrum(i).gt.maxg) maxg=spectrum(i)
 
	end do

cc	write(*,*) 'Max flux=', maxg
cc	write(*,*) 'g(13)=',spectrum(13)

	do i=1,npixel
		g_edge(i)=spectrum(i)
		spectrum(i)=spectrum(i)/maxg
		dummy=g_edge(i)/spectrum(i)
		errorspec(i)=errorspec(i)/dummy

c		IF (i.lt.300) THEN
c		WRITE(*,*)' g_edge(i)=',g_edge(i),' spectrum(i)=',spectrum(i)
c		WRITE(*,*)' g_edge(i)/spectrum(i) = ',dummy
c		END IF

		IF (spectrum(i).eq.0.) errorspec(i)=1.

c==	new: error enlargement/reduction
		errorspec(i)=errorspec(i)*errorfac
c==

	end do

cc	write(*,*) 'g(13)=',spectrum(13) 



c------------- jumping to startpixel ---------------------------

	specindex=startpix

c---------------------------------------------------------------


	open(13,file='./plot/deconv/input_spec.dat')
	do i=6,npixel

		write(13,*) i-5,spectrum(i),errorspec(i)

	end do
	close(13)
	
c----
c	specindex=0
c	specindex=1

c	specindex2=0
	specindex2=1

	chunk=1

c----	Reading input spectrum & IP


c************************************************************************
c
c
c	S T A R T    L O O P 
c
c
c************************************************************************

 500	continue
	
c	Reading 10 more pixel to avoid edge effects after
c	deconvolution 
c	write(*,*)'......creating g-vector......'

c----------------- normalizing g & s vector ----------------

c	Creating correct g- and s-vector:

c---	check if EOF is reached


	write(*,*)'starting pixel for chunk#: ',chunk,' = ',specindex


	if (specindex+sizg.gt.npixel) then

	specindex=specindex-1

	write(*,*)'OK, last chunk is larger than INPUT spectrum file:'
	write(*,*)'Number of pixels are:',npixel
	write(*,*)'Chunk would go until:',specindex+sizg
 
	write(*,*)'..replacing missing pixel with value of the last one'

	dummy=(specindex+sizg)-npixel

	write(*,*)'Reading only until pixel#=',specindex+(sizg-dummy)


	do i=1,sizg-dummy
		g(i)=spectrum(specindex+i) 
                s(i)=errorspec(specindex+i)
	end do

	write(*,*)'...now replacing last ',dummy,' pixels:'

	do i=(sizg-dummy)+1,sizg
		g(i)=spectrum(specindex+sizg-dummy)
		s(i)=errorspec(specindex+sizg-dummy)
	end do 	
	

c	write(*,*)'Wanna see g and s vector?'
c	read(*,*)reply

c	open(11,file='./plot/deconv/lastchunk.dat')
c	do i=1,sizg
c		write(*,*)i,g(i),s(i)
c		write(11,*)i,g(i),s(i)
c	end do
c	close(11)

c	write(*,*)'OK, done, continue?'
c	read(*,*)reply

c---

	else


c---	Reading g- and s-vectors:

c		do i=1,sizg
c			g(i)=spectrum(specindex+i)
c			s(i)=errorspec(specindex+i)
c		end do

	write(*,*)'...READING INPUT SPECTRUM:'
	write(*,*)'Range is: ',specindex,' -> ', specindex+(sizg-1)

	k=1
		do i=specindex,specindex+(sizg-1)
			g(k)=spectrum(i)
                        s(k)=errorspec(i)
			k=k+1
		end do

	write(*,*)'.....',k-1,' Pixel read...'
c---

	end if

c---------------------------------------------------------

c	if (chunk.gt.18) then
c
c	write(*,*)'Wanna see g and s vector?'
c       read(*,*)reply
c
c       do i=1,sizg
c                write(*,*)i,g(i),s(i)
c        end do
c
c        write(*,*)'OK, done, continue?'
c        read(*,*)reply
c
c
c	end if

c---	Normalizing:
c	maxg=0.

c	do i=1,sizg
c		if (g(i).gt.maxg) maxg=g(i)
c	end do

c	do i=1,sizg
c		g_edge(i)=g(i)
c		g(i)=g(i)/maxg
c		dummy=g_edge(i)/g(i)
c		s(i)=s(i)/dummy
c	end do


c	open(30,file='./plot/deconv/gtest.dat')
c	do i=1,sizg
c		write(30,*)i,g_edge(i),g(i),s(i)
c	end do
c	close(30)
c	write(*,*)'check the g-vectors..'
c	read(*,*)reply

c==================================================================
c	READING IP-FILE:
c
c	IP HAS TO BE TURNED AROUND SINCE IP-RECONSTR. WAS DONE 
c	IN WAVENUMBER CHUNKS!!!!!!
c==================================================================

	if (chunk.eq.1) then

	read(12,*)reply
	read(12,*)fn2
	write(*,*)'Reading input IP file:',fn2

	open(16,file='./plot/deconv/'//fn2)
	do i=1,sizphi

		read(16,*)dummy,phi_dummy(i)

	end do
	close(16)
c	write(*,*)'DONE...'

c---	turning around:
c2	testing wrong side?

	do i=1,sizphi
		phi(sizphi+1-i)=phi_dummy(i)
c2		phi(i)=phi_dummy(i)
	end do

c---	done.

	end if
c==================================================================

c	write(*,*)'g(13)=',g(13),' s(13)=',s(13)
c	write(*,*)'and phi(13)=',phi(13)

c	write(*,*)'Reading true solution....'
c	open(16,file='./plot/truef_2.dat')
c	open(16,file='./plot/deconv/truef.dat')
c
c	do i=1,sizf
c		read(16,*)truef(i)
c	end do
c	close(16)

c	write(*,*)'OK, continue?'
c	read(*,*)reply

	goto 1000

c*************************************************************************

c	Jumping over testdrive....
c	goto 1000
c-----	TEST:
c
c	sizphi=5
c	phi(1)=0.01
c	phi(2)=0.4
c	phi(3)=0.5
c	phi(4)=0.3
c	phi(5)=0.002
c
c	sumphi=0.
c
c	do i=1,sizphi
c		sumphi=sumphi+phi(i)
c	end do
c	do i=1,sizphi
c		phi(i)=phi(i)/sumphi
c		write(*,*)'Phi(',i,')=',phi(i)
c	end do
c
c	sizg=5
c	p=2
c	q=5
c	
c	do i=1,sizg
c		s(i)=0.01
c	end do
c
c
c	sizf=sizg*q+2*p
c	do i=1,sizf
c		f(i)=1.
c	end do
c	f(10)=0.5
c	f(20)=0.2
c
c	CALL MCONV(f,sizf,sizg,q,f_conv,phi,sizphi,sizfconv)
c	
c	write(*,*)'sizfconv=',sizfconv
c
c	open(10,file='./plot/ftest.dat')
c	do i=1,sizf
c		write(10,*)f(i),f_conv(i)
c	end do
c	close(10)
c
c	gdummy=0.
c       sizgsimu=0.
c       count=1 
c       j=1
c
c       do i=1,sizfconv
c                gdummy=gdummy+f_conv(i)   
c       write(*,*)'i ,count, j, g_new(i),gdummy',i,count,j,g_new(i),gdummy
c                count=count+1
c                if (count.gt.q) then
c                       count=1
c                        g_samp(j)=gdummy/q
c                       write(*,*)'gsimu(j)=',g_samp(j)
c                        j=j+1
c                        sizgsimu=sizgsimu+1
c                        gdummy=0.  
c                end if
c        end do
c
c	write(*,*)'sigsimu=',sizgsimu
c	gdummy=0.
c	do i=1,sizg
c		if (g_samp(i).gt.gdummy) gdummy=g_samp(i)
c	end do
c	do i=1,sizg
c		g_samp(i)=g_samp(i)/gdummy
c		g(i)=g_samp(i)
c	end do
c
c
c	open(10,file='./plot/gtest.dat')
c	do i=1,sizg
c		write(10,*)i,g(i),s(i),phi(i)
c	end do
c	close(10)
c------------------------ END OF TEST -------------------------------


c1000 	continue

c--------------- SIMULATION -----------------------------------------

	sizgtest=102
	sizftest=sizgtest*q

	do i=1,sizftest+2*p
		ftest(i)=1.
	end do

		ftest(200)=0.1
		ftest(201)=0.105
		ftest(202)=0.11
		ftest(203)=0.12
		ftest(204)=0.13
		ftest(205)=0.18
		ftest(206)=0.26
		ftest(207)=0.35
		ftest(208)=0.51
		ftest(209)=0.75
		ftest(210)=0.82
		ftest(211)=0.88
		ftest(212)=0.91
		ftest(213)=0.96
		ftest(214)=0.98

		ftest(199)=0.105
		ftest(198)=0.11
                ftest(197)=0.12
                ftest(196)=0.13
                ftest(195)=0.18
                ftest(194)=0.26
		ftest(193)=0.35
                ftest(192)=0.51
                ftest(191)=0.75
		ftest(190)=0.82
                ftest(189)=0.88
                ftest(188)=0.91
		ftest(187)=0.96
		ftest(186)=0.98



	call
& mconv(ftest,sizftest+2*p,sizgtest,q,ftest2,phi,sizphi,sizftest2)

	open(19,file='./plot/deconv/ftest.dat')
	do i=1,sizftest2
		write(19,*)ftest(p+i),ftest2(i)
	end do
	close(19)


c	downsampling:
	call down(ftest2,sizftest2,gtest2,sizgtest2,q)

c	adding noise:
	write(*,*)'=======> Adding noise:'
	call gaussn2(gtest2,gtest,phi,sizgtest2,5.)



	open(19,file='./plot/deconv/gtest2.dat')
	do i=1,sizgtest2
		write(19,*)gtest(i),gtest2(i)
	end do
	close(19)


	write(*,*)'End of simulation.....'
	read(*,*)reply


c------------------ END OF SIMULATION  -------------------------------




c************************************************************************
c
c
c
c
c			M 	E	M
c
c		D	E	C	O	N	V	
c
c
c************************************************************************



1000	continue

	write(*,*)'Calculating matrix...'
c	read(*,*)reply
	

c---------------------------------------------------------------------

c******	MATRIX: ***********

	CALL MCAL_MAT3(phi,sizphi,matPHI,p,q,sizf,sizg)

c**************************

c	normalizing matrix
	summatrix=0.
	
	do i=1,sizf
		summatrix=summatrix+matPHI(1,i)
	end do

	do i=1,sizg
		do k=1,sizf
			matPHI(i,k)=matPHI(i,k)/summatrix
		end do
	end do

c******


	write(*,*)'OK, matrix is ready'

c---------------------------------------------------------------------
c
c			M  E  M 
c
c---------------------------------------------------------------------

	do i=1,sizg
		g_mem(i)=g(i)
		s_mem(i)=s(i)
	end do


c	if (chunk.eq.nchunks) then
c		write(*,*)'OK, last chunk! INPUT OF QUICK='
c		do i=1,sizg
c			write(*,*)i,g_mem(i),s_mem(i)
c		end do
c	end if

	eta = eta_input

	if (chunk.eq.funny_chunk) THEN

	eta = eta_default

	WRITE(*,*) 'OJO! eta set to:', eta,' for this funny chunk!'

	END IF



c******************** DECONVOLUTION LOOP ************************

1142	CONTINUE
	WRITE(*,*)' => STARTING MEM ! ETA=',eta

	call quick(X,matPHI,g_mem,s_mem,sizg,sizf,niter,eta,0,n1
&      ,x1,x2,x3)

	fmax=0.

c	adaptive error:
	write(*,*)'Returned from quick: ',n1

	IF (n1.eq.1) THEN
		WRITE(*,*)'ACHTUNG! EMPTY CHUNK => reducing error!'
		do i=1,sizg
                s_mem(i)=s_mem(i)*0.95
	        end do
		eta = eta_input
		if (chunk.eq.funny_chunk) THEN
        	eta = eta_default
	        WRITE(*,*) 'OJO! eta set to:', eta,' for this funny chunk!'
	        END IF
		GOTO 1142
	END IF


c	write(*,*)'Normalizing...'
c	write(*,*)'Size of f-vector=',sizf

c	do i=1,sizf
c		if (X(i).gt.fmax) then
c			fmax=X(i)
c		end if
c	end do
	
c	error=0.

	do i=1,sizf
		f(i)=X(i)
c		f(i)=X(i)/fmax
c		error=error+(truef(i)-f(i))**2.
	end do


	
c*******************************************************************
c---	Outputfile:

	do i=1,sizg
		gsimu(i)=0.
		do k=1,sizf
			gsimu(i)=gsimu(i)+matPHI(i,k)*f(k)
		end do
	end do

	open(23,file='./plot/deconv/deconv2.dat')
	do i=1,sizg-(2*overlap)
		write(23,*)i,g(overlap+i),s(overlap+i),gsimu(overlap+i)
	end do
	close(23)

c	call mconv(f,sizf,sizg,q,f_conv,phi,sizphi,sizfconv)

c	open(23,file='./plot/deconv/deconv3.dat')
c	do i=1,sizfconv
c		write(23,*)f_conv(i)
c	end do
c	close(23)

c        do i=1,sizf-2*p-(2*overlap*q)
c        do i=1,sizf
c               resid(i)=truef(i)-f(i)
c                write(15,*)f(i),truef(i),resid(i)
c                write(15,*)f(49+i),phi(i)

c		write(15,*)f(p+overlap*q+i),phi(i)

c       end do

c****** writing to deconvolved spectrum array:

	write(*,*)'...WRITING OUTPUT SPECTRUM:'
	write(*,*)'Range is: ',specindex2,' ->
& ',specindex2+((sizg-2*overlap)*q)-1

	specindex2=specindex2-1

	do i=1,((sizg-2*overlap)*q)
		spec_deconv(specindex2+i)=f(p+(overlap*q)+i)
	end do

	specindex2=specindex2+1

c	do i=1,sizf-2*p-(2*overlap*q)
c		spec_deconv(specindex2+i)=f(p+overlap*q+i)
c	end do

c	if (chunk.eq.1) specindex2=1
c	specindex2=specindex2+sizf-2*p-(2*overlap*q)

	specindex2=specindex2+((sizg-2*overlap)*q)

	write(*,*)'OK, NEW start-index for deconv.Spectrum=',specindex2

c*********************************************************

	open(23,file='./plot/deconv/deconv4.dat')
	do i=1,sizf-2*p-(2*overlap*q)
c		write(23,*)spec_deconv(specindex2+i)
		write(23,*)f(p+overlap*q+i)
	end do
	close(23)

	open(23,file='./plot/deconv/deconv5.dat')
	do i=1,sizg-2*overlap
		dummy=i*q-2
	write(23,*)dummy,g(overlap+i),s(overlap+i),gsimu(overlap+i)
	end do
	close(23)

	write(*,*)'Output written to files...'

c******************** END OF DECONV ***********************

	goto 9000
	
c-------------------------------------------------------------------------
c---	Checking chi2: Convolution of f-vec*phi

	write(*,*)'CONVOLUTION-CHECK:'


	CALL MCONV(f,sizf,sizg,q,f_conv,phi,sizphi,sizfconv)

	fchi2=0.
	
	open(10,file='./plot/f_conv.dat')
        do i=1,sizfconv
                write(10,*)f_conv(i)        
                g_simu(i)=f_conv(i)
                
        end do          
        close(10)
                

c       creating g_samp as equally sampled vector

        gdummy=0.
        sizgsimu=0.
        count=1
        j=1
	dummy=0.

        do i=1,sizfconv
                gdummy=gdummy+g_simu(i)   
c       write(*,*)'i ,count, j, g_new(i),gdummy',i,count,j,g_new(i),gdummy
                count=count+1
                if (count.gt.q) then
                        count=1
                        g_samp(j)=gdummy/q
			if (g_samp(j).gt.dummy) dummy=g_samp(j)
c                       write(*,*)'gsimu(j)=',g_simu(j)
                        j=j+1
                        sizgsimu=sizgsimu+1
                        gdummy=0.  
                end if
        end do         

	do i=1,sizg
		g_samp(i)=g_samp(i)/dummy
                fchi2=fchi2+((g(i)-g_samp(i))/s(i))**2
        
        end do 
	
	open(10,file='./plot/g_samp.dat')
	do i=1,sizg
		write(10,*)i,g(i),g_samp(i),s(i)
	end do
	close(10)



	write(*,*)'CHI2 after convolution=',fchi2

c****************** NEXT CHUNK ******************************************

9000	continue

	write(*,*)
	write(*,*)'-----------------------------------------'
	write(*,*)'BUENO! Chunk Nr.',chunk,' deconvolved....'
	write(*,*)'-----------------------------------------'
	write(*,*)
c	write(*,*)'Ready for some more?'
c	read(*,*)reply

	chunk=chunk+1


c	if (chunk.eq.2) specindex=1
c	if (chunk.eq.2) specindex=startpix-overlap


	write(*,*)'Index of Inputspectrum is now:',specindex
	specindex=specindex+sizg-2*overlap
	write(*,*)'Specindex is now:',specindex


	if (chunk.gt.nchunks) goto 13000

c==================================================================
c       READING NEXT IP-FILE:
c
c       OJO! IP HAS TO BE TURNED AROUND SINCE IP-RECONSTR. WAS DONE
c       IN WAVENUMBER CHUNKS!!!!!!
c==================================================================

        read(12,*)fn2
        write(*,*)'Reading next input IP file:',fn2
                
c	write(*,*)'Okay, to proceed?'
c	read(*,*)reply

        open(16,file='./plot/deconv/'//fn2)
        do i=1,sizphi

                read(16,*)dummy,phi_dummy(i)

        end do
        close(16)
        write(*,*)'DONE...'

c---    turning around:
c	testing not to turn around:

        do i=1,sizphi
                phi(sizphi+1-i)=phi_dummy(i)
c		phi(i)=phi_dummy(i) 
        end do

c---    done.

	goto 500


c==========================================================================
c	THE END MY FRIEND
c==========================================================================

13000	continue

	close(15)
	close(17)
c	closing INPUT file:
	close(12)

	open(12,file='./plot/deconv/spec_deconv.dat')
	specindex2=specindex2-1
	do i=1,specindex2
		write(12,*)i,spec_deconv(i)
	end do
	close(12)
	write(*,*)specindex2,' deconvolved Pixel written to Outputfile'
	write(*,*)'======> spec_deconv.dat'
	write(*,*)
 

	write(*,*)'EL FIN....'
	write(*,*)'Hasta proxima cerveca....'

	END


c==========================================================================
        SUBROUTINE MCONV2(f,sizf,sizg,q,f_conv,phi,sizphi,sizfconv)

c       **************************************************************
c       * this routine convolves the vector f with the vector phi
c       **************************************************************

c       *  f_conv    oversampled & convolved model vector  OUTPUT
c       *  f         oversampled & not conv. model vector  INPUT
c       *  sizg      size of the observed vector           INPUT
c       *  sizf      =sizg*q                               INPUT
c       *  q         oversampling factor                   INPUT
c       *  phi       instrumental profile for the conv.    INPUT
c       *  sizphi    size of IP vector                     INPUT
c       *  sizfconv  size of f_conv                        OUTPUT

        INTEGER i,sizf,sizphi,j,k,sizg,p,sizgnew,sizgsimu,q,count 
        INTEGER sizfconv
        REAL f(1000),phi(1000),g_simu(1000),g_new(1000),conv(1000)
        REAL f_conv(1000)
        REAL gdummy
c       REAL sumphi,sumidu

        CHARACTER reply

c       write(*,*)'Size of vector PHI=',sizphi
c       write(*,*)'Size of input vector f=',sizf

        p=sizphi/2

        sizgsimu=0

c       write(*,*)'Cut off value for Phi, p=',p

        
        do j=1,sizf
        
                sumidu=0. 
        
                do k=1,sizphi
        
c                       if (j.eq.50) then

c                           write(*,*)'k ,Phi(k)',k,phi(k)
c                           write(*,*)'(j-(p+1)+k)=',j-(p+1)+k
c                           write(*,*)'f(j-(p+1)+k)=',f(j-(p+1)+k)
c             write(*,*)'f(j-(p+1)+k)*Phi(k)=',f(j-(p+1)+k)*phi(k)
c                       write(*,*)'sumidu=',sumidu
c
c                       end if
        
        
                 if ((j-(p+1)+k).gt.0) then

                  sumidu=sumidu+(f(j-(p+1)+k)*phi(k))

                 end if
        


                end do

                conv(j)=sumidu
                sizgsimu=sizgsimu+1

c               if (j.eq.23) then
c               write(*,*)'Value of convolved vector(23)',conv(j)
c               end if
        
                 
        end do
                  
        sizfconv=sizf 
        
                 
c       open(17,file='./plot/mconv2.dat')
c                 
        do i=1,sizfconv
                f_conv(i)=conv(i)
c               write(17,*)f_conv(i),f(i),phi(i)
        end do
c       close(17)  

        return

        end     






c===========================================================================
	SUBROUTINE MCAL_MAT3(phi,sizphi,matPHI,p,q,sizf,sizg)
	
	IMPLICIT NONE

	INTEGER maxsize
	PARAMETER(maxsize=5000)

	INTEGER sizf,sizg,sizphi,q,p
	REAL phi(maxsize),f(maxsize),matPHI(maxsize,maxsize)
	INTEGER j,js,i,k
	REAL sumphi,jsdown,jsup,jup,jdown

c	write(*,*)'THIS IS MCAL_MAT3!'
c	write(*,*)'Size of Phi=',sizphi
c	write(*,*)'Size of g-vector=',sizg
	sizf=sizg*q+2*p
c	write(*,*)'SIZE of deconvolved & overs. f-vector=',sizf
c	write(*,*)'Oversampling=',q
c	write(*,*)'IP cut-off=',p


	i=1
	k=1
	
c	open(10,file='./plot/deconv/testmat.dat')

c	do i=1,sizg
	do i=0,sizg-1


c	jdown=q*i-2*p
c	jup=q*(i+1)+p-1-p

	jup=q*(i+1)+p-1
	jdown=q*i-p

c	write(*,*)'i=',i,' jdown=',jdown,' jup=',jup

		do j=jdown,jup

c			jsdown=q*i-j+1	
c			jsup=q*(i+1)-j

			jsup=q*(i+1)-j-1
			jsdown=q*i-j


			sumphi=0.
c			write(*,*)'JSUP=',jsup
c			write(*,*)'JSDOWN=',jsdown
c			write(10,*)'J=',j

				do js=jsdown,jsup
c				write(*,*)'js=',js
				if ((p+1)+js.gt.0.and.js+(p+1).le.sizphi) then
					sumphi=sumphi+phi((p+1)+js)
c	write(*,*)'SUM-PHI=',sumphi,'PHI(',(p+1)+js,')=',phi((p+1)+js)
c					write(*,*)'NOW IT COUNTS!'		
				end if
				end do

			matPHI(i+1,k)=sumphi
c			write(*,*)'matPHI(',i+1,'',k,')=',matPHI(i+1,k)
			k=k+1
		
		end do

	k=1+((i+1)*q)

	end do

c	do i=1,sizg
c		do k=1,sizf
c		write(10,*)'matPHI(',i,'',k,')=',matPHI(i,k)
c		end do
c	end do


c	close(10)


	RETURN
	END
	
c====================================================================
	subroutine f1const(f_1,ampl,width)

	real*8 ampl,step
	real f_1(1000)
	integer width,start,end

	do i=1,185
                f_1(i)=0.
        end do

c	write(*,*)'WIDTH=',width	
c	write(*,*)'AMPLITUDE=',ampl

        f_1(93)=ampl

	if (width.gt.0) then

		step=ampl/(width+1)
c		write(*,*)'STEP=',step
		
		start=93-(width+1)
		end=93+(width+1)

		do i=1,width
			f_1(start+i)=step*i
			f_1(end-i)=step*i
		end do

	end if


	return
	end
c====================================================================

	subroutine down(overs,oversize,downs,downsize,factor)

	real overs(9000),downs(9000)
	integer factor,oversize,downsize,count,k,i,l


	downsize=0.
	k=1
        count=1
        do i=1,oversize
                downs(k)=downs(k)+overs(i)
                count=count+1
                if (count.eq.factor+1) then
                        downs(k)=downs(k)/factor
                        count=1
                        k=k+1
			downsize=downsize+1
                end if
        end do
 
	write(*,*)'OK, Size of downsampled data=',downsize



	return
	end
c====================================================================

      SUBROUTINE RNECUY(U,N)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION U(N)
      PARAMETER (M1=2147483563,M1MIN1=2147483562,IA1=40014,
     +           IQ1=53668,IR1=12211)
      PARAMETER (M2=2147483399,IA2=40692,IQ2=52774,IR2=2791)
      PARAMETER (XM1INV=4.656613E-10)
      DATA IX1,IX2 /123456, 654321/
      DO 10 I=1,N
C Produce integer random number X1 from first MLCG
        K=IX1/IQ1
        IX1=IA1*(IX1-K*IQ1)-K*IR1
        IF (IX1.LT.0) IX1=IX1+M1
C Produce integer random number X2 from second MLCG
        K=IX2/IQ2
        IX2=IA2*(IX2-K*IQ2)-K*IR2
        IF (IX2.LT.0) IX2=IX2+M2
C Combine
        IZ=IX1-IX2
        IF(IZ.LT.1) IZ=IZ+M1MIN1
C Normalize and transform to floating point
        U(I)=REAL(IZ)*XM1INV
   10 CONTINUE
      RETURN
C Input of seed
      ENTRY RNE2IN(ISEED1,ISEED2)
      IX1=ISEED1
      IX2=ISEED2
      RETURN
C Output of seed
      ENTRY RNE2OT(ISEED1,ISEED2)
      ISEED1=IX1
      ISEED2=IX2
      RETURN
      END

C------------------------------------------------------------------------
